/**
  Generated main.c file from MPLAB Code Configurator

  @Company
    Microchip Technology Inc.

  @File Name
    main.c

  @Summary
    This is the generated main.c using PIC24 / dsPIC33 / PIC32MM MCUs.

  @Description
    This source file provides main entry point for system intialization and application code development.
    Generation Information :
        Product Revision  :  PIC24 / dsPIC33 / PIC32MM MCUs - 1.85
        Device            :  PIC24FJ256GB106
    The generated drivers are tested against the following:
        Compiler          :  XC16 v1.35
        MPLAB 	          :  MPLAB X v5.05
 */

/*
    (c) 2016 Microchip Technology Inc. and its subsidiaries. You may use this
    software and any derivatives exclusively with Microchip products.

    THIS SOFTWARE IS SUPPLIED BY MICROCHIP "AS IS". NO WARRANTIES, WHETHER
    EXPRESS, IMPLIED OR STATUTORY, APPLY TO THIS SOFTWARE, INCLUDING ANY IMPLIED
    WARRANTIES OF NON-INFRINGEMENT, MERCHANTABILITY, AND FITNESS FOR A
    PARTICULAR PURPOSE, OR ITS INTERACTION WITH MICROCHIP PRODUCTS, COMBINATION
    WITH ANY OTHER PRODUCTS, OR USE IN ANY APPLICATION.

    IN NO EVENT WILL MICROCHIP BE LIABLE FOR ANY INDIRECT, SPECIAL, PUNITIVE,
    INCIDENTAL OR CONSEQUENTIAL LOSS, DAMAGE, COST OR EXPENSE OF ANY KIND
    WHATSOEVER RELATED TO THE SOFTWARE, HOWEVER CAUSED, EVEN IF MICROCHIP HAS
    BEEN ADVISED OF THE POSSIBILITY OR THE DAMAGES ARE FORESEEABLE. TO THE
    FULLEST EXTENT ALLOWED BY LAW, MICROCHIP'S TOTAL LIABILITY ON ALL CLAIMS IN
    ANY WAY RELATED TO THIS SOFTWARE WILL NOT EXCEED THE AMOUNT OF FEES, IF ANY,
    THAT YOU HAVE PAID DIRECTLY TO MICROCHIP FOR THIS SOFTWARE.

    MICROCHIP PROVIDES THIS SOFTWARE CONDITIONALLY UPON YOUR ACCEPTANCE OF THESE
    TERMS.
 */

/**
  Section: Included Files
 */
#include "mcc_generated_files/system.h"
#include "mcc_generated_files/pin_manager.h"
#include "mcc_generated_files/tmr1.h"
#include "mcc_generated_files/tmr2.h"
#include "mcc_generated_files/adc1.h"
#include "./../Character_LCM.h"
#include "mcc_generated_files/uart1.h"
#include "mcc_generated_files/oc1.h"
#include <stdio.h>
#include <string.h>

/*
                         Main application
 */

unsigned long i = 0;
volatile unsigned int ADCResult[2];
volatile unsigned char AD1Flag = 0;
volatile unsigned char T1Flag = 0;
unsigned int Counter = 0;
unsigned char UARTBuffer[ 100 ];

int main(void)
{
    // initialize the device
    SYSTEM_Initialize();

    LCM_Init();

    LCM_SetCursor(0, 0);
    LCM_PutROMString((const unsigned char *) "PIC24FJ256GB106");
    LCM_SetCursor(0, 1);
    LCM_PutROMString((const unsigned char *) "VR1:    ,VR2:   ");

    while (1)
    {
        // Add your application code
        if (AD1Flag)
        {
            AD1Flag = 0;
            LCM_SetCursor(4, 1);
            LCM_PutNumber(ADCResult[0], 4);
            LCM_SetCursor(13, 1);
            LCM_PutNumber(ADCResult[1] >> 1, 3);

            if (ADCResult[0] >= 1023)
                OC1_PrimaryValueSet(OC1RS + 1);
            else
                OC1_PrimaryValueSet(((long) ADCResult[0] * OC1RS) / 1023);
        }

        if (T1Flag)
        {
            T1Flag = 0;
            if (!UART1_TransmitBufferIsFull())
            {
                sprintf((char *) UARTBuffer, "Now Counter : %4d\r\n", Counter++);
                UART1_WriteBuffer((const uint8_t *) UARTBuffer, strlen((const char *) UARTBuffer));
            }
        }

        if (!UART1_ReceiveBufferIsEmpty())
        {
            LCM_SetCursor(15, 0);
            LCM_PutASCII(UART1_Read());
        }

        if (S1_GetValue())
            D8_SetLow();
        else
            D8_SetHigh();
    }

    return 1;
}

void TMR1_CallBack(void)
{
    D1_Toggle();
    D2_Toggle();
    T1Flag = 1;
}

void TMR2_CallBack(void)
{
    D3_Toggle();
    D4_Toggle();
}

void ADC1_CallBack(void)
{
    ADC1_ConversionResultBufferGet((uint16_t *) ADCResult);
    AD1Flag = 1;
}
/**
 End of File
 */

